import 'package:flutter_code_push/Environment.dart';
import 'package:flutter_code_push/constant/WTVMConstant.dart';
import 'package:flutter_code_push/declaration/WTBaseDeclaration.dart';
import 'package:flutter_code_push/pointer/WTClassPointer.dart';
import 'package:flutter_code_push/external/WTByteArray.dart';

/// 简单的标识符
class WTSimpleIdentifierImpl extends WTBaseDeclaration {
  /// 标识符
  String identifierName;

  WTSimpleIdentifierImpl.instance(this.identifierName);
  WTSimpleIdentifierImpl();

  @override
  dynamic execute(Environment env) {
    return env.get(identifierName);
  }

  @override
  void read(ByteArray byteArray) {
    this.identifierName = byteArray.readString();
  }

  @override
  String toString() {
    return identifierName;
  }
}
